{
Easy Shutdown - shuts the computer down after a specific time

Copyright (C) 2010 Meister0815

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, see http://www.gnu.org/licenses/.
}

unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics,
  Spin, StdCtrls, ExtCtrls, ComCtrls, Process;

type
  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ProgressBar1: TProgressBar;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure ShutdownLinux;
var p: TProcess;
begin
  if FileExists('/usr/bin/dbus-send') then
  begin
    p:=TProcess.Create(nil);
    p.Options:=[poStderrToOutPut];
    writeLn('Shutting down Linux...');
    p.CommandLine:='dbus-send --system --print-reply --dest=org.freedesktop.ConsoleKit /org/freedesktop/ConsoleKit/Manager org.freedesktop.ConsoleKit.Manager.Stop';
    p.Execute;
    p.Free;
    halt(0);
  end
  else writeLn('DBus command line utility not found!');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Timer1.Enabled then
    begin
      Timer1.Enabled:= false;
      Timer2.Enabled:= false;
      ProgressBar1.Position:= 0;
      SpinEdit1.Enabled:=true;
      SpinEdit2.Enabled:=true;
      Button1.Caption:= 'Start';
    end
  else
    begin
      Timer1.Enabled:= true;
      Timer2.Enabled:= true;
      SpinEdit1.Enabled:=false;
      SpinEdit2.Enabled:=false;
      Button1.Caption:= 'Stop';
      if (SpinEdit1.Value=0) and (SpinEdit2.Value=0) then
        ShutdownLinux;
    end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  // Countdown
  ProgressBar1.Position:= 0;
  if (SpinEdit1.Value>0) and (SpinEdit2.Value=0) then
    begin
      SpinEdit1.Value:= SpinEdit1.Value - 1;
      SpinEdit2.Value:= 59;
    end
  else
    SpinEdit2.Value:= SpinEdit2.Value - 1;
  // Shutdown
  if (SpinEdit1.Value=0) and (SpinEdit2.Value=0) then
    ShutdownLinux;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  ProgressBar1.Position:= ProgressBar1.Position + 1;
end;

initialization
  {$I unit1.lrs}

end.

